/*
Copyright (c) AppDynamics, Inc., and its affiliates
2015
All Rights Reserved
 */
'use strict';


function GlobalProbe(agent) {
  this.agent = agent;
}
exports.GlobalProbe = GlobalProbe;



GlobalProbe.prototype.attach = function(obj) {
  var self = this;
  var proxy = self.agent.proxy;
  var thread = self.agent.thread;
  var fns = ['setTimeout', 'setInterval', 'setImmediate'];

  if(obj.__appdynamicsProbeAttached__) return;
  obj.__appdynamicsProbeAttached__ = true;
  self.agent.on('destroy', function() {
    if(obj.__appdynamicsProbeAttached__) {
      delete obj.__appdynamicsProbeAttached__;
      fns.forEach(function(fn) {
        proxy.release(obj[fn]);
      });
    }
  });

  // we need these for thread simulation
  proxy.before(obj, fns, function(obj, args) {
    var threadId = thread.current();
    proxy.callback(args, 0, function() {
      thread.resume(threadId);
    });
  });
};